(define build-solution
  (lambda (legal-pl)
    (if (= (length legal-pl) 8)
	legal-pl
	(forward 8 legal-pl))))

(define forward
  (lambda (try legal-pl)
    (if (zero? try)
	(backtrack legal-pl)
	(if (legal? try legal-pl)
	    (build-solution (cons try legal-pl))
	    (forward (- try 1) legal-pl)))))

(define backtrack
  (lambda (legal-pl)
    (if (null? legal-pl)
	'()
	(forward (- (car legal-pl) 1) (cdr legal-pl)))))

(define legal?
  (lambda (try legal-pl)
    (good? legal-pl (+ 1 try) (- try 1) try)))

(define good?
  (lambda (new-pl up down try)
    (if (null? new-pl)
	#t
	(let ((next-pos (car new-pl)))
	  (and
	    (not (= next-pos try))
	    (not (= next-pos up))
	    (not (= next-pos down))
	    (good? (cdr new-pl)
		   (add1 up)
		   (sub1 down)
		   try))))))
